#include <dirent.h>
#include <errno.h>
#include <fcntl.h>
#include <stdarg.h>
#include <stdbool.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>

#define N_ELEMENTS(arr) (sizeof(arr) / sizeof((arr)[0]))

#define arg_unused __attribute__((unused))

#define autofree __attribute__((cleanup(cleanup_free)))
#define autoclose __attribute__((cleanup(cleanup_close)))
#define autoclosedir __attribute__((cleanup(cleanup_closedir)))

extern bool opt_verbose;

static inline void cleanup_free(void *p)
{
	free(*(void **)p);
}

static inline void cleanup_close(const int *fd)
{
	if (*fd >= 0)
		close(*fd);
}

static inline void cleanup_closedir(DIR **dir)
{
	if (*dir)
		closedir(*dir);
}

static inline void *steal_ptr(void *_pp)
{
	void **pp = (void **)_pp;
	void *p = NULL;

	p = *pp;
	*pp = NULL;

	return p;
}

__attribute__((__format__(printf, 1, 2))) extern void verbose(const char *format, ...);
__attribute__((__format__(printf, 1, 2))) extern void error(const char *format, ...);
__attribute__((__noreturn__)) __attribute__((__format__(printf, 1, 2))) extern void
fatal(const char *format, ...);
__attribute__((__noreturn__)) extern void oom(void);

extern bool str_has_prefix(const char *str, const char *prefix);
extern bool str_has_suffix(const char *str, const char *suffix);
extern char *join_path(const char *a, const char *b);
extern char *read_file(const char *filename);
char **str_split(char *row, char split_at, size_t *size);
